window.Gleam.initSearch([{"doc":"carpenter","title":"carpenter","content":"# carpenter 🔨\n\n[![Package Version](https://img.shields.io/hexpm/v/carpenter)](https://hex.pm/packages/carpenter)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/carpenter/)\n\nBindings for Erlang&#39;s [ETS tables](https://www.erlang.org/doc/man/ets.html). Forked and updated from [gts](https://github.com/Lunarmagpie/gts). \n\nIf you aren&#39;t familiar with ETS tables, [this](https://elixirschool.com/en/lessons/storage/ets) is a good introduction.\n\n\n## Quick start\n\n```gleam\nimport gleam/io\nimport ets/builder\nimport ets/table/set\n\npub fn main() {\n  let set: set.Set(String, String) =\n    builder.new(&quot;table_name&quot;)\n    |&gt; builder.set()\n\n  set\n  |&gt; set.insert(&quot;hello&quot;, &quot;world&quot;)\n\n  set\n  |&gt; set.lookup(&quot;hello&quot;)\n  |&gt; set.debug\n}\n```\n\n## Installation\n\nThis package is available on hex:\n\n```sh\ngleam add carpenter\n```\n\nIts documentation can be found at &lt;https://hexdocs.pm/carpenter&gt;.\n","url":"index.html"},{"doc":"carpenter/table","title":"Table","content":"pub opaque type Table(k, v)\n\n\nSynonyms:\ncarpenter/table.Table\ncarpenter/table Table","url":"carpenter/table.html#Table"},{"doc":"carpenter/table","title":"drop","content":"pub fn drop(table: Table(a, b)) -&gt; Nil\n Deletes the entire table.\nSynonyms:\ncarpenter/table.drop\ncarpenter/table drop","url":"carpenter/table.html#drop"},{"doc":"carpenter/table","title":"give_away","content":"pub fn give_away(\n  table: Table(a, b),\n  pid: Pid,\n  gift_data: c,\n) -&gt; Nil\n Give the table to another process.\nSynonyms:\ncarpenter/table.give_away\ncarpenter/table give_away","url":"carpenter/table.html#give_away"},{"doc":"carpenter/table","title":"name","content":"pub fn name(table: Table(a, b)) -&gt; Atom\n\nSynonyms:\ncarpenter/table.name\ncarpenter/table name","url":"carpenter/table.html#name"},{"doc":"carpenter/table","title":"new","content":"pub fn new(name: Atom) -&gt; Table(a, b)\n\nSynonyms:\ncarpenter/table.new\ncarpenter/table new","url":"carpenter/table.html#new"},{"doc":"carpenter/table","title":"carpenter/table","content":" Generic operations on every table type.","url":"carpenter/table.html"},{"doc":"carpenter/table/set","title":"Set","content":"pub type Set(k, v) =\n  set.Set(k, v)\n\n\nSynonyms:\ncarpenter/table/set.Set\ncarpenter/table/set Set","url":"carpenter/table/set.html#Set"},{"doc":"carpenter/table/set","title":"delete","content":"pub fn delete(set: Set(a, b), key: a) -&gt; Set(a, b)\n Delete all objects with key `key` from the table.\nSynonyms:\ncarpenter/table/set.delete\ncarpenter/table/set delete","url":"carpenter/table/set.html#delete"},{"doc":"carpenter/table/set","title":"insert","content":"pub fn insert(set: Set(a, b), key: a, value: b) -&gt; Set(a, b)\n Insert a value into the ets table.\nSynonyms:\ncarpenter/table/set.insert\ncarpenter/table/set insert","url":"carpenter/table/set.html#insert"},{"doc":"carpenter/table/set","title":"lookup","content":"pub fn lookup(set: Set(a, b), key: a) -&gt; Option(b)\n Retrieve a value from the ets table. Return an option if the value could\n not be found.\nSynonyms:\ncarpenter/table/set.lookup\ncarpenter/table/set lookup","url":"carpenter/table/set.html#lookup"},{"doc":"carpenter/table/set","title":"table","content":"pub fn table(set: Set(a, b)) -&gt; Table(a, b)\n Return the table for this set object.\nSynonyms:\ncarpenter/table/set.table\ncarpenter/table/set table","url":"carpenter/table/set.html#table"},{"doc":"carpenter/table/set","title":"carpenter/table/set","content":"","url":"carpenter/table/set.html"},{"doc":"carpenter/table/ordered_set","title":"OrderedSet","content":"pub type OrderedSet(k, v) =\n  ordered_set.OrderedSet(k, v)\n\n\nSynonyms:\ncarpenter/table/ordered_set.OrderedSet\ncarpenter/table/ordered_set OrderedSet","url":"carpenter/table/ordered_set.html#OrderedSet"},{"doc":"carpenter/table/ordered_set","title":"delete","content":"pub fn delete(set: OrderedSet(a, b), key: a) -&gt; OrderedSet(a, b)\n Delete all objects with key `key` from the table.\nSynonyms:\ncarpenter/table/ordered_set.delete\ncarpenter/table/ordered_set delete","url":"carpenter/table/ordered_set.html#delete"},{"doc":"carpenter/table/ordered_set","title":"insert","content":"pub fn insert(\n  set: OrderedSet(a, b),\n  key: a,\n  value: b,\n) -&gt; OrderedSet(a, b)\n Insert a value into the ets table.\nSynonyms:\ncarpenter/table/ordered_set.insert\ncarpenter/table/ordered_set insert","url":"carpenter/table/ordered_set.html#insert"},{"doc":"carpenter/table/ordered_set","title":"lookup","content":"pub fn lookup(\n  set: OrderedSet(a, b),\n  key: a,\n) -&gt; Option(List(#(a, b)))\n Retrieve a value from the ets table. Return an option if the value could\n not be found.\nSynonyms:\ncarpenter/table/ordered_set.lookup\ncarpenter/table/ordered_set lookup","url":"carpenter/table/ordered_set.html#lookup"},{"doc":"carpenter/table/ordered_set","title":"table","content":"pub fn table(set: OrderedSet(a, b)) -&gt; Table(a, b)\n Return the table for this set object.\nSynonyms:\ncarpenter/table/ordered_set.table\ncarpenter/table/ordered_set table","url":"carpenter/table/ordered_set.html#table"},{"doc":"carpenter/table/ordered_set","title":"carpenter/table/ordered_set","content":"","url":"carpenter/table/ordered_set.html"},{"doc":"carpenter/config/write_concurrency","title":"WriteConcurrency","content":"pub type WriteConcurrency {\n  True\n  False\n  Auto\n}\n\nTrue\n\n\nFalse\n\n\nAuto\n\n\nSynonyms:\ncarpenter/config/write_concurrency.WriteConcurrency\ncarpenter/config/write_concurrency WriteConcurrency","url":"carpenter/config/write_concurrency.html#WriteConcurrency"},{"doc":"carpenter/config/write_concurrency","title":"carpenter/config/write_concurrency","content":"","url":"carpenter/config/write_concurrency.html"},{"doc":"carpenter/config/privacy","title":"Privacy","content":"pub type Privacy {\n  Private\n  Protected\n  Public\n}\n\nPrivate\n\n\nProtected\n\n\nPublic\n\n\nSynonyms:\ncarpenter/config/privacy.Privacy\ncarpenter/config/privacy Privacy","url":"carpenter/config/privacy.html#Privacy"},{"doc":"carpenter/config/privacy","title":"carpenter/config/privacy","content":"","url":"carpenter/config/privacy.html"},{"doc":"carpenter/builder","title":"TableBuilder","content":"pub type TableBuilder(k, v) {\n  TableBuilder(\n    name: String,\n    privacy: Option(privacy.Privacy),\n    write_concurrency: Option(write_concurrency.WriteConcurrency),\n    read_concurrency: Option(Bool),\n    decentralized_counters: Option(Bool),\n    compressed: Bool,\n  )\n}\n\nTableBuilder(\n  name: String,\n  privacy: Option(privacy.Privacy),\n  write_concurrency: Option(write_concurrency.WriteConcurrency),\n  read_concurrency: Option(Bool),\n  decentralized_counters: Option(Bool),\n  compressed: Bool,\n)\n\n\nSynonyms:\ncarpenter/builder.TableBuilder\ncarpenter/builder TableBuilder","url":"carpenter/builder.html#TableBuilder"},{"doc":"carpenter/builder","title":"build_table","content":"pub fn build_table(\n  builder: TableBuilder(a, b),\n  table_type: String,\n) -&gt; Atom\n\nSynonyms:\ncarpenter/builder.build_table\ncarpenter/builder build_table","url":"carpenter/builder.html#build_table"},{"doc":"carpenter/builder","title":"compression","content":"pub fn compression(\n  builder: TableBuilder(a, b),\n  compressed: Bool,\n) -&gt; TableBuilder(a, b)\n\nSynonyms:\ncarpenter/builder.compression\ncarpenter/builder compression","url":"carpenter/builder.html#compression"},{"doc":"carpenter/builder","title":"decentralized_counters","content":"pub fn decentralized_counters(\n  builder: TableBuilder(a, b),\n  counters: Bool,\n) -&gt; TableBuilder(a, b)\n\nSynonyms:\ncarpenter/builder.decentralized_counters\ncarpenter/builder decentralized_counters","url":"carpenter/builder.html#decentralized_counters"},{"doc":"carpenter/builder","title":"new","content":"pub fn new(name: String) -&gt; TableBuilder(a, b)\n\nSynonyms:\ncarpenter/builder.new\ncarpenter/builder new","url":"carpenter/builder.html#new"},{"doc":"carpenter/builder","title":"ordered_set","content":"pub fn ordered_set(\n  builder: TableBuilder(a, b),\n) -&gt; OrderedSet(a, b)\n\nSynonyms:\ncarpenter/builder.ordered_set\ncarpenter/builder ordered_set","url":"carpenter/builder.html#ordered_set"},{"doc":"carpenter/builder","title":"privacy","content":"pub fn privacy(\n  builder: TableBuilder(a, b),\n  privacy: Privacy,\n) -&gt; TableBuilder(a, b)\n\nSynonyms:\ncarpenter/builder.privacy\ncarpenter/builder privacy","url":"carpenter/builder.html#privacy"},{"doc":"carpenter/builder","title":"read_concurrency","content":"pub fn read_concurrency(\n  builder: TableBuilder(a, b),\n  con: Bool,\n) -&gt; TableBuilder(a, b)\n\nSynonyms:\ncarpenter/builder.read_concurrency\ncarpenter/builder read_concurrency","url":"carpenter/builder.html#read_concurrency"},{"doc":"carpenter/builder","title":"set","content":"pub fn set(builder: TableBuilder(a, b)) -&gt; Set(a, b)\n\nSynonyms:\ncarpenter/builder.set\ncarpenter/builder set","url":"carpenter/builder.html#set"},{"doc":"carpenter/builder","title":"write_concurrency","content":"pub fn write_concurrency(\n  builder: TableBuilder(a, b),\n  con: WriteConcurrency,\n) -&gt; TableBuilder(a, b)\n\nSynonyms:\ncarpenter/builder.write_concurrency\ncarpenter/builder write_concurrency","url":"carpenter/builder.html#write_concurrency"},{"doc":"carpenter/builder","title":"write_concurrency_prop","content":"pub fn write_concurrency_prop(prop: WriteConcurrency) -&gt; Dynamic\n\nSynonyms:\ncarpenter/builder.write_concurrency_prop\ncarpenter/builder write_concurrency_prop","url":"carpenter/builder.html#write_concurrency_prop"},{"doc":"carpenter/builder","title":"carpenter/builder","content":"","url":"carpenter/builder.html"},{"doc":"carpenter/table/bag","title":"carpenter/table/bag","content":"","url":"carpenter/table/bag.html"},{"doc":"carpenter/table/duplicate_bag","title":"carpenter/table/duplicate_bag","content":"","url":"carpenter/table/duplicate_bag.html"}]);